---
id: iac
title: Infrastructure as code
sidebar_label: IAC
slug: /iac
---



## What is provisioning?
-------------------------

The aim of provisioning is to use software tools to automatically control the installation, configuration, and management
of the environment that the user is trying to configure. The aim of this chapter is to explore how can infrastructure as
code be seen as a security solution and what are the advantages, disadvantages, alternatives, and challenges that come with
this method.


## What is IAC?
-----------------------------

Infrastructure as code is the process of managing and provisioning networking, storage, and computing elements of a data center
through the use of definition files, rather than physical hardware configuration or interactive configuration tools.

Some of the first questions that come to cyber-security expert minds when hearing about this method are “How is this related to
cybersecurity?” followed closely by “Why should I use it?”. The main advantages of it are the following: cost, speed, and risk
reduction. The first 2 reasons are enticing enough but the third one is the most alluring. Through the documentation of all codes
guaranteed that the human error element is being controlled.

Because all resources that are being created are being documented through code it is easier to manage. Because all infrastructure
is centralized it can be easily maintained and because it is in a code format it can be securely managed through version control
pipelines. Which in turn helps with the government of credentials needed to login through the use of environment variables and
secured token management.

On the market, there is a multitude of tools that can be used to achieve this very goal. Each of the major cloud platforms
comes equipped with its own respective service. [AWS](../../portofolio/glossary#aws-amazon-web-services) comes with CloudFormation, Azure comes with Resource Manager, and Google
Cloud comes with a Deployment manager. On top of this, every major cloud platform has APIs that enable all these actions to be
programmed by hand.

To top it all off, there are tools that can be used for all available platforms such as Terraform, Ansible, and Chef.  The former
tools are better suited for solutions that aim to run on multiple platforms as they are not vendor locked to one cloud platform.

Between all the platform-agnostic tools available it is hard to make a decision on which one is best suited. Luckily, there are
criteria that can be used to determine the best tool, the criteria used in this case was community support, security-oriented,
fit with a tool used by the company and ease of use based on the use case.

Both [Ansible](../../portofolio/glossary#ansible) and Terraform have a large community, in the same way, both Ansible and Terraform have a Masterless and Agentless
system of deployment meaning they do not need to preinstall an agent on the machines they are provisioning avoiding security
issues that may arise from open ports needed for communication. Most of the company’s tools for managing images security are
Hashicorp based, therefore, Terraform gains an advantage due to that.

Finally, the most important difference between Ansible and Terraform is the method they function Ansible is procedural while 
Terraform is declarative. 
What this means is that Ansible will deploy all the machines declared in the code regardless of whether it is already running or
not, Terraform on the other hand looks at the wanted result and ensures the end result of the code is achieved, avoiding killing
important parts of the infrastructure in the process of redeployment. This final difference-making Terraform one of the best
options at the moment from security and use case perspective.


